
checked = false
mod_plr = {}

FRAME_RATE = 60

-- EASING --
local path = GAMESTATE:GetCurrentSong():GetSongDir()..'lua/'
loadfile(path..'easing.lua')()
loadfile(path..'modhelpers.lua')()
loadfile(path.."mods.lua")()

local bun_flicker = 1

local bun_height_ratio = SCREEN_HEIGHT/480
local bun_width_ratio = SCREEN_WIDTH/640
local bun_sdwidth_ratio = (480*(SCREEN_WIDTH/SCREEN_HEIGHT))/640

local function Plr(pn)
	if GAMESTATE:IsPlayerEnabled(pn-1) then
		return SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
	else
		return nil
	end
end
function GetJud(pn)
	return _G['jud'..pn]
end
function GetCom(pn)
	return _G['com'..pn]
end

function mod_do(str,pn)
	if pn then
		if GAMESTATE:IsPlayerEnabled(pn-1) then
			taronuke_mods(str,pn)
		end
	else
		for pn=1,2 do
			if GAMESTATE:IsPlayerEnabled(pn-1) then
				taronuke_mods(str,pn)
			end
		end
	end
end

	function bun_Sound(str)
		local met = GAMESTATE:GetCurrentSong():GetSongDir();
		SOUND:PlayOnce(met..'lua/'..str..'.ogg');
	end
	
	math.clamp = function(v,mi,ma)
		if v > ma then return ma
		elseif v < mi then return mi
		else return v end
	end
	
	function pool_create(name)
		_G['bun_pool_'..name] = {}
		_G['bun_pool_'..name..'_ptr'] = 1
	end
	
	function pool_get(name)
		if _G['bun_pool_'..name] then
			local a = _G['bun_pool_'..name][ _G['bun_pool_'..name..'_ptr'] ]
			local b = _G['bun_pool_'..name..'_ptr']
			
			_G['bun_pool_'..name..'_ptr'] = _G['bun_pool_'..name..'_ptr']+1
			
			if _G['bun_pool_'..name..'_ptr'] > table.getn(_G['bun_pool_'..name]) then
				_G['bun_pool_'..name..'_ptr'] = 1
			end
			
			return a, b
		else
			SCREENMAN:SystemMessage('Bad pool name: '..name)
			return nil, nil
		end
	end
	
	function pool_get_unused(name)
		if _G['bun_pool_'..name] then
			local a = _G['bun_pool_'..name][ _G['bun_pool_'..name..'_ptr'] ]
			local b = _G['bun_pool_'..name..'_ptr']
			
			_G['bun_pool_'..name..'_ptr'] = _G['bun_pool_'..name..'_ptr']+1
			
			while a:getaux() ~= 0 do
				a = _G['bun_pool_'..name][ _G['bun_pool_'..name..'_ptr'] ]
				b = _G['bun_pool_'..name..'_ptr']
				_G['bun_pool_'..name..'_ptr'] = _G['bun_pool_'..name..'_ptr']+1
			end
			
			if _G['bun_pool_'..name..'_ptr'] > table.getn(_G['bun_pool_'..name]) then
				_G['bun_pool_'..name..'_ptr'] = 1
			end
			
			return a, b
		else
			SCREENMAN:SystemMessage('Bad pool name: '..name)
			return nil, nil
		end
	end
	
	function pool_add(obj,name)
		if _G['bun_pool_'..name] then
			obj:addcommand('Hide',function(o) o:visible(false) end)
			table.insert(_G['bun_pool_'..name],obj)
		else
			SCREENMAN:SystemMessage('Bad pool name: '..name)
		end
	end
	
	function pool_table(name)
		return _G['bun_pool_'..name]
	end
	
	function pool_size(name)
		if _G['bun_pool_'..name] then
			return table.getn(_G['bun_pool_'..name])
		end
		return 0
	end
	
	function pool_clear(name)
		
		if _G['bun_pool_'..name] then
			for i=1,pool_size(name) do
				local a = _G['bun_pool_'..name][i]
				if a then
					a:finishtweening()
					a:visible(false)
					a:aux(0)
				end
			end
		end
		
	end
	
	pool_create('ligma')
	
	lig_status = {}

-- ALIASES --
--These make it so the syntax for the table entries matches the syntax for the nITG template.
--If you want to prefix all your calls with "modhelpers.", "ease.", etc., then you won't need this and can remove this section.
local linear, inQuad, outQuad, inOutQuad, outInQuad, inCubic, outCubic, inOutCubic, outInCubic, inQuart,outQuart, inOutQuart, outInQuart, inQuint, outQuint, inOutQuint, outInQuint, inSine, outSine, inOutSine,outInSine, inExpo, outExpo, inOutExpo, outInExpo, inCirc, outCirc, inOutCirc, outInCirc, inElastic,outElastic, inOutElastic, outInElastic, inBack, outBack, inOutBack, outInBack, inBounce, outBounce,inOutBounce, outInBounce = ease.linear, ease.inQuad, ease.outQuad, ease.inOutQuad, ease.outInQuad,ease.inCubic, ease.outCubic, ease.inOutCubic, ease.outInCubic, ease.inQuart, ease.outQuart,ease.inOutQuart, ease.outInQuart, ease.inQuint, ease.outQuint, ease.inOutQuint, ease.outInQuint,ease.inSine, ease.outSine, ease.inOutSine, ease.outInSine, ease.inExpo, ease.outExpo, ease.inOutExpo,ease.outInExpo, ease.inCirc, ease.outCirc, ease.inOutCirc, ease.outInCirc, ease.inElastic,ease.outElastic, ease.inOutElastic, ease.outInElastic, ease.inBack, ease.outBack, ease.inOutBack,ease.outInBack, ease.inBounce, ease.outBounce, ease.inOutBounce, ease.outInBounce

local perframe, mod_insert, mod2_insert, mod_ease, mod_perframe, mod_message, mod_blacklist, simple_m0d, simple_m0d2, simple_m0d3, mod_wiggle, mod_spring, mod_springt, mod_springt2, mod_spring_adjustable, mod_onebeat, switcfino_add, switcfino_reset, mod_sugarkiller, modulo, reverseRotation, randomXD, mod_bounce, ease_wiggle, ease_wiggleAbs = modhelpers.perframe, modhelpers.mod_insert, modhelpers.mod2_insert, modhelpers.mod_ease, modhelpers.mod_perframe, modhelpers.mod_message, modhelpers.mod_blacklist, modhelpers.simple_m0d, modhelpers.simple_m0d2, modhelpers.simple_m0d3, modhelpers.mod_wiggle, modhelpers.mod_spring, modhelpers.mod_springt, modhelpers.mod_springt2, modhelpers.mod_spring_adjustable, modhelpers.mod_onebeat, modhelpers.switcfino_add, modhelpers.switcfino_reset, modhelpers.mod_sugarkiller, modhelpers.modulo,modhelpers.reverseRotation, modhelpers.randomXD, modhelpers.mod_bounce, modhelpers.ease_wiggle, modhelpers.ease_wiggleAbs



			local m = mod_insert
			local m2 = mod_message
			local me = mod_ease
			
			
			local l = 'len'
			local e = 'end'
			
			
			
			
			
			
			
			init_modsp1 = ''
			init_modsp2 = ''
			
			mod_plr = {}
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat() --necessary to prevent long freezes
			
			
			
			
			
			
			
			
			
			
			
---------------------------------------------------------------------------------------
----------------------Begin tables 'n stuff--------------------------------------------
---------------------------------------------------------------------------------------

			--beat based mods
			--{beat_start, beat_end, mods, len_or_end, player_number}
			mods = {
				{0,9999,'*1000 no beat, stealthpastreceptors, stealthtype','end'},
			}
			
			--switcfinos = {{0,0},{100,0},{0,100},{25,-75},{75,75},{25,125},{75,-125},{100,-100}}
			
			
			
			
			
			
			
			
			--this is both a message broadcaster and a function runner
			--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
			--if you put {beat,function() somecode end}, then function() is run at that beat
			--see example on beat 32
			
			curaction = 1
			--{beat,thing,persists}
			mod_actions = {
			
			
				
			}
			
			
			
			
			
			
			--beat-based ease mods
			--{time_start, time_end, mod_start, mod_end, mod, len_or_end, ease_type, player_number, sustaintime, optional_param1, optional_param2}
			--valid ease types are:
				--linear
				--inQuad    outQuad    inOutQuad    outInQuad
				--inCubic   outCubic   inOutCubic   outInCubic
				--inQuart   outQuart   inOutQuart   outInQuart
				--inQuint   outQuint   inOutQuint   outInQuint
				--inSine    outSine    inOutSine    outInSine
				--inExpo    outExpo    inOutExpo    outInExpo
				--inCirc    outCirc    inOutCirc    outInCirc
				--inElastic outElastic inOutElastic outInElastic    --can take 2 optional parameters - amplitude & period
				--inBack    outBack    inOutBack    outInBack       --can take 1 optional parameter  - spring amount
				--inBounce  outBounce  inOutBounce  outInBounce
				
			mods_ease = {
				-- EXAMPLE TWEEN: from beat 0 to 4, make rotationz go from 360 to 0 with the inOutBack tween
				--{0,4,360,0,'rotationz','end',inOutBack},
			}
			
			
			
			mod_perframes = {
				
			}
			
			function mpf(s,e,f)
				table.insert(mod_perframes,{s,e,f})
			end
			
			
			m2(1,function()
				
				Trace("hahahaha.")
				
				
			end)
			
			
			local spb = 60/132
			
			function ligma_configma(x,y,amt)
				for j=1,amt do
					local a,b = pool_get('ligma')
					if a then
						local c = lig_status[b]
						
						
						a:animate(0)
						a:blend('BlendMode_Add')
						a:visible(true)
						a:setstate(math.random(0,3))
						
						a:halign(55/64)
						
						a:zoom(0.8 + math.random() * 0.6)
						
						c.xspd = 70*(0.3 + math.random() * 3)
						c.yspd = 100*(-3 + math.random() * 4)
						
						a:x(x + c.xspd * 3/FRAME_RATE)
						a:y(y + c.yspd * 3/FRAME_RATE)
						
						c.alpha = 1
						
						c.active = true;
						
						if math.mod(j,2) == 0 then
							c.xspd = c.xspd*-1
						end
					end
				end
			end
			
			ligma_grav = 12
			--ligma update
			mpf(0,999,function(beat)
				
				if table.getn(lig_status) == 0 then
					for i=1,pool_size('ligma') do
						table.insert(lig_status,{actor = pool_table('ligma')[i], xspd=0, yspd=0, alpha=0, active=false})
					end
				end
				
				for i=1,table.getn(lig_status) do
					local a = lig_status[i]
					if a and a.active then
						
						a.yspd = a.yspd + ligma_grav
						a.alpha = a.alpha - 2.4*(1/FRAME_RATE)
						
						a.actor:addx(a.xspd * (1/FRAME_RATE))
						a.actor:addy(a.yspd * (1/FRAME_RATE))
						a.actor:diffusealpha(math.clamp(a.alpha,0,1))
						
						local ang = math.atan2(a.yspd,a.xspd)
						a.actor:rotationz(math.deg(ang))
						
						if a.alpha < 0 then
							a.actor:visible(false)
							a.active = false;
						end
						
					end
				end
				
			end)
			
			local function tingting(beat,dir)
				local dir = dir
				m2(beat,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX()-110*dir,a:GetY()-100,6)
							a:sleep(0)
							a:rotationz(-5*dir)
							a:decelerate(30/132)
							a:rotationz(0)
						end
					end
				end)
				m2(beat+.5,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX()-110*dir,a:GetY()-100,6)
							a:sleep(0)
							a:rotationz(-5*dir)
							a:decelerate(30/132)
							a:rotationz(0)
						end
					end
				end)
				m2(beat+1,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX()-110*dir,a:GetY()-100,6)
							a:sleep(0)
							a:rotationz(-5*dir)
							a:decelerate(30/132)
							a:rotationz(0)
						end
					end
				end)
				m2(beat+1.5,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX()-110*dir,a:GetY()-100,6)
							a:sleep(0)
							a:rotationz(-5*dir)
							a:decelerate(30/132)
							a:rotationz(0)
						end
					end
				end)
			end
			
			function tingting2(beat)
				me(beat,0.5,20,0,'invert',l,outCubic)
				me(beat+0.5,0.5,-20,0,'invert',l,outCubic)
				me(beat+1,0.5,20,0,'invert',l,outCubic)
				me(beat+1.5,0.5,-20,0,'invert',l,outCubic)
				m2(beat,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX()-64,a:GetY()-112,3)
							ligma_configma(a:GetX()+64,a:GetY()-112,3)
						end
					end
				end)
				m2(beat+0.5,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX(),a:GetY()-112,3)
						end
					end
				end)
				m2(beat+1,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX()-64,a:GetY()-112,3)
							ligma_configma(a:GetX()+64,a:GetY()-112,3)
						end
					end
				end)
				m2(beat+1.5,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX(),a:GetY()-112,3)
						end
					end
				end)
			end
			function ting2(beat)
				me(beat,0.5,20,0,'invert',l,outCubic)
				me(beat+0.5,0.5,-20,0,'invert',l,outCubic)
				m2(beat,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX()-64,a:GetY()-112,3)
							ligma_configma(a:GetX()+64,a:GetY()-112,3)
						end
					end
				end)
				m2(beat+0.5,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							ligma_configma(a:GetX(),a:GetY()-112,3)
						end
					end
				end)
			end
			
			local function bwew(beat,hei,dur)
				local hei=hei
				m2(beat-.05,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							a:linear(.05)
							a:zoomy(hei)
							a:decelerate(dur*45/132)
							a:zoomy(1)
						end
					end
				end)
				m2(beat+1-.05,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							a:linear(.05)
							a:zoomy(hei)
							a:decelerate(dur*45/132)
							a:zoomy(1)
						end
					end
				end)
			end
			
			for k=0,11 do
				tingting(5 + 8*k, (math.mod(k,2)*2-1))
				if k < 11 then
					tingting2(165 + 8*k)
				end
				tingting(261 + 8*k, (math.mod(k,2)*2-1))
			end
			
			ting2(191)
			ting2(220)
			
			function bouncecol(b,c,h)
				local lm = (c==2) and -1 or 1
				me(b,0.5,0,-h*lm,'split',l,outCubic)
				me(b+.5,0.5,-h*lm,0,'split',l,inCubic)
				me(b,0.5,0,h,'cross',l,outCubic)
				me(b+.5,0.5,h,0,'cross',l,inCubic)
				me(b,0.5,0,h*lm,'alternate',l,outCubic)
				me(b+.5,0.5,h*lm,0,'alternate',l,inCubic)
				m(b+1,1,'*100 no split, *100 no cross, *100 no alternate',l)
			end
			
			bouncecol(199,2,-20)
			mod_onebeat(200,150)
			
			bouncecol(207,1,10)
			mod_onebeat(208,-150)
			
			bouncecol(219,1,10)
			
			m2(217,function()
				for pn=1,2 do
					local a = Plr(pn)
					if a then
						a:skewx(.1)
						a:sleep(30/132)
						a:skewx(-.1)
						a:sleep(30/132)
						a:skewx(0)
					end
				end
			end)
			
			m2(239,function()
				for pn=1,2 do
					local a = Plr(pn)
					if a then
						a:skewx(.1)
						a:sleep(30/132)
						a:skewx(-.1)
						a:sleep(30/132)
						a:skewx(0)
					end
				end
			end)
			
			me(158,1,0,15,'reverse',l,outCubic)
			me(159,1,15,0,'reverse',l,inCubic)
			
			for i = 160,252,4 do
				mod_onebeat(i,100)
			end
			
			bouncecol(215,2,5)
			
			m(231,233,'*10000 no stealth')
			m(231,.125,'*10000 30 stealth')
			m(231.25,.125,'*10000 30 stealth')
			m(231.5,.125,'*10000 30 stealth')
			m(231.75,.125,'*10000 30 stealth')
			
			me(236.5,1,628,0,'confusionoffset',l,outExpo)
			
			me(223,.5,0,20,'tornado',l,outCubic)
			me(223.5,1,20,0,'tornado',l,inOutCubic)
			m(224,1,'*1000 no tornado')
			
			for i=0,5 do
				local amt = 1 + .18*(1-(i/8))
				local dur = .25 + .6*(1-(i/8))
				bwew(225+4*i,amt,dur)
			end
			
			m2(253,function()
				SCREENMAN:GetTopScreen():zoomz(2.5)
				SCREENMAN:GetTopScreen():linear(120/132)
				SCREENMAN:GetTopScreen():zoomz(1)
				for pn=1,2 do
					local a = Plr(pn)
					if a then
						a:rotationx(-30)
						a:zoom(.7)
						a:decelerate(30/132)
						a:zoom(.85)
						a:sleep(0)
						a:rotationx(-20)
						a:zoom(.7)
						a:decelerate(30/132)
						a:zoom(.9)
						a:sleep(0)
						a:rotationx(-10)
						a:zoom(.7)
						a:decelerate(30/132)
						a:zoom(.95)
						a:sleep(0)
						a:rotationx(0)
						a:zoom(.7)
						a:decelerate(30/132)
						a:zoom(1)
					end
				end
			end)
			
			m(255-0.04,.5,'*1000 10 invert',l)
			m(255.25-0.04,.5,'*1000 no invert',l)
			m(255.5-0.04,.5,'*1000 10 invert',l)
			m(255.75-0.04,.5,'*1000 no invert',l)
			
			mod_onebeat(247,100)
			bouncecol(247,2,5)
			mod_onebeat(248,100)
			bouncecol(249,1,-10)
			mod_onebeat(250,-100)
			bouncecol(251,2,10)
			mod_onebeat(252,100)
			
			m2(335.5,function()
				for pn=1,2 do
					local a = Plr(pn)
					if a then
						a:decelerate(30/132)
						a:zoom(0)
					end
				end
			end)
			
			function modtable_compare(a,b)
				return a[1] < b[1]
			end
			
			if table.getn(mod_actions) > 1 then
				table.sort(mod_actions, modtable_compare)
			end
			


local ac = Def.ActorFrame{
	Name= "xtl_actor_d",
	Def.Actor{ OnCommand= function(s) mod_firstSeenBeat = GAMESTATE:GetSongBeat() s:sleep(9e9) end },
	Def.Actor{ InitCommand= function(s) my_auxvar = s end,
	},
	Def.Actor{
		
		OnCommand=function(s)
			s:queuecommand('Update')
		end,
		UpdateCommand=function(self)
		
			bun_flicker = bun_flicker * -1
			
			if GAMESTATE:GetSongBeat()>=0 and not checked then
			
				--name players, judgment and combo
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil
					if _G['P'..pn] then
						_G['jud'..pn] = _G['P'..pn]:GetChild('Judgment')
						_G['com'..pn] = _G['P'..pn]:GetChild('Combo')
					end
					
				end
				
				screen = SCREENMAN:GetTopScreen()
				checked = true --let this only run once
				
			end

			local beat = GAMESTATE:GetSongBeat()
			
			
---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false
			if disable ~= true and beat > mod_firstSeenBeat+0.1 and checked then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				for i=1,2 do
					--mod_do('clearall',i)
				end
				
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				for i,v in pairs(mods) do
					if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
						if beat >=v[1] then
							if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
								if table.getn(v) == 5 then
									mod_do(v[3],v[5])
								else
									mod_do(v[3])
								end
							end
						end
					else
						v[1] = 0
						v[2] = 0
						v[3] = ''
						v[4] = 'error'
						SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')')
					end
				end
				
				--------------------------------------------------------------------------------------
				-- i dont know who this reader is but he looks like he is made out of EASE HAHAHAHA --
				-- original code by exschwasion, bastardized by taro for cmod support and less 'if' --
				--------------------------------------------------------------------------------------
				for i,v in pairs(mods_ease) do
					if v and table.getn(v) > 6 and v[1] and v[2] and v[3] and v[4] and v[5] and v[6] and v[7] then
						if beat >=v[1] then
							if (v[6] == 'len' and beat <=v[1]+v[2]) or (v[6] == 'end' and beat <=v[2]) then
								
								local duration = v[2]
								if v[6] == 'end' then duration = v[2] - v[1] end
								local curtime = beat - v[1]
								local diff = v[4] - v[3]
								local startstrength = v[3]
								local curve = v[7]
								local mod = v[5]
								
								local strength = curve(curtime, startstrength, diff, duration, v[10], v[11]) --extra parameters for back and elastic eases :eyes:
								
								local modstr = v[5] == 'xmod' and strength..'x' or (v[5] == 'cmod' and 'C'..strength or strength..' '..v[5])
								mod_do('*10000 '..modstr,v[8])
								
							elseif (v[9] and ((v[6] == 'len' and beat <=v[1]+v[2]+v[9]) or (v[6] == 'end' and beat <=v[9]))) then
							
								local strength = v[4]
								
								local modstr = v[5] == 'xmod' and strength..'x' or (v[5] == 'cmod' and 'C'..strength or strength..' '..v[5])
								mod_do('*10000 '..modstr,v[8])
								
							end
						end
					else
						SCREENMAN:SystemMessage('Bad mod in beat-based ease table (line '..i..')')
					end
				end
				
				--------------------
				-- Perframe stuff --
				--------------------
				
				----------------------------------------
				-- HBLBHCBLBJGBHL DO THIS EVERY FRAME --
				----------------------------------------
				
				if table.getn(mod_perframes)>0 then
					for i=1,table.getn(mod_perframes) do
						local a = mod_perframes[i]
						if beat > a[1] and beat < a[2] then
							a[3](beat)
						end
					end
				end
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
					if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
						if type(mod_actions[curaction][2]) == 'function' then
							mod_actions[curaction][2]()
						elseif type(mod_actions[curaction][2]) == 'string' then
							MESSAGEMAN:Broadcast(mod_actions[curaction][2])
						end
					end
					curaction = curaction+1
				end
				
			end
			
			self:sleep(1/FRAME_RATE)
			self:queuecommand('Update')

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
	
	}
}


for i=1,64 do
	ac[#ac+1] = Def.Sprite { Texture="ligma_fast", OnCommand=cmd(visible,false;queuecommand,"Make"), MakeCommand=function(self) pool_add(self,'ligma') end }
end

return ac